Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sourceforge.pmd.stat
Class StatisticalRule

    java.lang.Object
      net.sourceforge.pmd.CommonAbstractRule
          net.sourceforge.pmd.AbstractJavaRule
              net.sourceforge.pmd.stat.StatisticalRule

All Implemented Interfaces:
  JavaParserVisitor, Rule

Direct Known Subclasses:
  AbstractNcssCount, ExcessiveLengthRule, ExcessiveNodeCountRule, NpathComplexity, SwitchDensityRule

    public abstract class StatisticalRule

extends AbstractJavaRule

Author:
  David Dixon-Peugh Aug 8, 2002 StatisticalRule.java

Field Summary
`static double` | `DELTA`

Fields inherited from interface net.sourceforge.pmd.Rule
`LOWEST_PRIORITY, PRIORITIES`

Constructor Summary
`StatisticalRule()`

Method Summary
`void` | `addDataPoint(DataPoint point)`
`void` | `apply(java.util.List acus, RuleContext ctx)` Apply this rule to the given collection of compilation units, using the given context.
`protected java.util.SortedSet<DataPoint>` | `applyMinimumValue(java.util.SortedSet<DataPoint> pointSet, double minValue)`
`protected java.util.SortedSet<DataPoint>` | `applyTopScore(java.util.SortedSet<DataPoint> points, int topScore)`
`protected double` | `getMean()`
`protected double` | `getStdDev()`
`protected void` | `makeViolations(RuleContext ctx, java.util.Set<DataPoint> p)`
`protected java.util.Map<java.lang.String,PropertyDescriptor>` | `propertiesByName()` Return all the relevant properties for the receiver by overriding in subclasses as necessary.

Methods inherited from class net.sourceforge.pmd.AbstractJavaRule
`addViolation, addViolation, addViolation, addViolationWithMessage, getDeclaringType, importsPackage, isQualifiedName, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visitAll`

Methods inherited from class net.sourceforge.pmd.CommonAbstractRule
`addExample, addProperties, addProperty, addRuleChainVisit, asFixedMap, asFixedMap, end, equals, getBooleanProperties, getBooleanProperty, getBooleanProperty, getDescription, getDoubleProperties, getDoubleProperty, getDoubleProperty, getExample, getExamples, getExternalInfoUrl, getIntProperties, getIntProperty, getIntProperty, getMessage, getName, getPriority, getPriorityName, getProperties, getRuleChainVisits, getRuleClass, getRuleSetName, getSince, getStringProperties, getStringProperty, getStringProperty, getTypeProperties, getTypeProperty, hashCode, hasProperty, include, propertyDescriptorFor, setDescription, setExternalInfoUrl, setInclude, setMessage, setName, setPriority, setProperties, setProperty, setRuleClass, setRuleSetName, setSince, setUsesDFA, setUsesTypeResolution, start, usesDFA, usesRuleChain, usesTypeResolution`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### DELTA

    public static final double DELTA

See Also:
  Constant Field Values

Constructor Detail

### StatisticalRule

    public StatisticalRule()

Method Detail

### addDataPoint

    public void addDataPoint(DataPoint point)

### apply

    public void apply(java.util.List acus,
                      RuleContext ctx)

  Description copied from interface: `Rule`
  Apply this rule to the given collection of compilation units, using the given context.

  Specified by:
    `apply` in interface `Rule`
  Overrides:
    `apply` in class `AbstractJavaRule`

### getMean

    protected double getMean()

### getStdDev

    protected double getStdDev()

### applyMinimumValue

    protected java.util.SortedSet<DataPoint> applyMinimumValue(java.util.SortedSet<DataPoint> pointSet,
                                                               double minValue)

### applyTopScore

    protected java.util.SortedSet<DataPoint> applyTopScore(java.util.SortedSet<DataPoint> points,
                                                           int topScore)

### makeViolations

    protected void makeViolations(RuleContext ctx,
                                  java.util.Set<DataPoint> p)

### propertiesByName

    protected java.util.Map<java.lang.String,PropertyDescriptor> propertiesByName()

  Description copied from class: `CommonAbstractRule`
  Return all the relevant properties for the receiver by overriding in subclasses as necessary.

  Overrides:
    `propertiesByName` in class `CommonAbstractRule`
  Returns:
    Map

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2009 InfoEther. All Rights Reserved.